var restClient = require('./src/restclient');
var gtxClient = require('./src/gtx/gtxclient');
var gtx = require('./src/gtx/gtx');
const gtv = require('./src/gtv');
exports.restClient = restClient;
exports.gtx = gtx;
exports.gtv = gtv;
exports.gtxClient = gtxClient;
var util = require('./src/util');
exports.util = util;

let crypto = require('crypto');
let secp256k1 = require('secp256k1');

var blockchainRID = '0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF';

let signerPrivKeyA = Buffer.alloc(32, 'a');
let signerPubKeyA = Buffer.from('02e5a018b3a2e155316109d9cdc5eab739759c0e07e0c00bf9fccb8237fe4d7f02', 'hex');
//let signerPubKeyA = secp256k1.publicKeyCreate(signerPrivKeyA);
//console.log(signerPubKeyA.toString('hex'));
let signerPrivKeyB = Buffer.alloc(32, 'b');
let signerPubKeyB = secp256k1.publicKeyCreate(signerPrivKeyB);

// The lower-level client that can be used for any
// postchain client messages. It only handles binary data.
var rest = restClient.createRestClient("http://localhost:7740", blockchainRID);

// Create an instance of the higher-level gtx client. It will
// use the rest client instance and it will allow calls to functions
// fun1 and fun2. The backend implementation in Postchain must
// provide those functions.
var gtxcs = gtxClient.createClient(rest, Buffer.from(blockchainRID, 'hex'), ["create_user", "nop"]);

// Start a new request. A request instance is created.
// The public keys are the keys that must sign the request
// before sending it to postchain. Can be empty.
var req = gtxcs.newTransaction([signerPubKeyA]);

// call fun1 with three arguments: a string, an array and a Buffer
//req.addOperation("insert_city_dict", {"name": "Hamburg"});
req.addOperation('create_user', signerPubKeyA, "Peter");
req.addOperation('nop', 1000);
/*
req.addOperation("create_user", new dynamic[] {pubKey, "Peter"});
req.addOperation("nop", new dynamic[] {1000});
*/


req.sign(signerPrivKeyA, signerPubKeyA);

req.postAndWaitConfirmation();
